
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>redux教程之源码解析3applyMiddleware（分析在注释中） / 憋错料</title>

    <meta name="description" content="redux教程之源码解析3applyMiddleware（分析在注释中） applyMiddleware是另一个核心函数 首先我们需要知道如何使用中间件 eg: import { createStore, applyMiddleware } from 'redux' import todos from './reducers' function logger({ getState }) { return (next) =&gt; (action) =&gt; { console.log('will dispatch', action) // 调用 middleware ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">redux教程之源码解析3applyMiddleware（分析在注释中）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<pre>applyMiddleware是另一个核心函数
首先我们需要知道如何使用中间件
eg:
import { createStore, applyMiddleware } from ‘redux‘
import todos from ‘./reducers‘

function logger({ getState }) {
  return (next) =&gt; (action) =&gt; {
    console.log(‘will dispatch‘, action)

    // 调用 middleware 链中下一个 middleware 的 dispatch。
    let returnValue = next(action)

    console.log(‘state after dispatch‘, getState())

    // 一般会是 action 本身，除非
    // 后面的 middleware 修改了它。
    return returnValue
  }
}

let store = createStore(
  todos,
  [ ‘Use Redux‘ ],
  applyMiddleware(logger)
)

store.dispatch({
  type: ‘ADD_TODO‘,
  text: ‘Understand the middleware‘
})
</pre>
<pre>中间件其实就是对reducer就行功能扩展，例如上面的例子，logger即在执行reducer时，输出正在执行的action名字
const a = [()=&gt;{console.log(1)},()=&gt;{console.log(2)},()=&gt;{console.log(3)},()=&gt;{console.log(4)}]
undefined
const b = a.reduce((a, b) =&gt; (...args) =&gt; a(b(...args)))
undefined
b(1)
VM8485:1 4
VM8485:1 3
VM8485:1 2
VM8485:1 1
undefined</pre>
<pre>源码
export default function applyMiddleware(...middlewares) {
  /**返回一个新的createStore函数 */
  return createStore =&gt; (...args) =&gt; {
    /**通过传入的reducer和action生成store */
    const store = createStore(...args)
    let dispatch = () =&gt; {
      throw new Error(
        `Dispatching while constructing your middleware is not allowed. ` +
          `Other middleware would not be applied to this dispatch.`
      )
    }
    /**对store和disptch改变成动态的，这样每次传入一个middleware的Store和disptch都是上一个middleware处理过的 */
    const middlewareAPI = {
      getState: store.getState,
      dispatch: (...args) =&gt; dispatch(...args)
    }
    const chain = middlewares.map(middleware =&gt; middleware(middlewareAPI))
    /**链式处理函数，即依次执行middleware数组中的各个中间件 */
    dispatch = compose(...chain)(store.dispatch)

    /**将所有中间件对reducer的扩展加入后，返回store和dispatch */
    return {
      ...store,
      dispatch
    }
  }
}</pre>

<p>原文地址：https://www.cnblogs.com/qdcnbj/p/12687041.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-22 13:34:07 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/this/" title="this">this</a>, <a href="https://www.biecuoliao.com/tag/row/" title="row">row</a>, <a href="https://www.biecuoliao.com/tag/turn/" title="turn">turn</a>, <a href="https://www.biecuoliao.com/tag/%e5%8a%a8%e6%80%81/" title="动态">动态</a>, <a href="https://www.biecuoliao.com/tag/other/" title="other">other</a>, <a href="https://www.biecuoliao.com/tag/struct/" title="struct">struct</a>, <a href="https://www.biecuoliao.com/tag/creates/" title="creates">creates</a>, <a href="https://www.biecuoliao.com/tag/%e5%b0%b1%e6%98%af/" title="就是">就是</a>, <a href="https://www.biecuoliao.com/tag/the/" title="The">The</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>redux教程之源码解析3applyMiddleware（分析在注释中）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4N8xEG0.html" rel="bookmark">redux教程之源码解析createStore</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				redux源码 redux的源码很简单,分为以下几部分 createStore combineReducers applyMiddleware compose bindActionCreators createStore即入口函数生成store,将reducer和middleware关联起来 combineReducers即将分散的reducer最终合并成一个统一的reducer applyMiddleware即将多个中间件一次合并到reducer中,生成一个最终的reducer compose			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/412RDJM.html" rel="bookmark">只需一句话就能搞定NVelocity模板引擎，源码&plus;解析&plus;文档&plus;资料&plus;注释</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				好长时间不发技术方面的动态了,今天无聊就发篇关于NVelocity的技术文章吧,这门技术来源于java开源项目Velocity,比较好用,其他的我也不过多介绍了,没听过的在文章末尾会有介绍,下面我们就实战吧~ 咱们直接上最简单的方法,一句话搞定: DNTNvelocityHelper.NvelocityTemplate(context.Request.MapPath(&quot;~/NVelocity/templates/&quot;), context, &quot;Templater_index.dn			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVmoQx4.html" rel="bookmark">volley源码解析&lpar;四&rpar;--CacheDispatcher从缓存中获取数据</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				从上一篇文章我们已经知道,现在要处理的问题就是CacheDispatcher和NetworkDispatcher怎么分别去缓存和网络获取数据的问题,这两个问题我分开来讲. 但是首先说明的是,这两个问题其实是有联系的,当CacheDispatcher获取不到缓存的时候,会将request放入网络请求队列,从而让NetworkDispatcher去处理它: 而当NetworkDispatcher获得数据以后,又会将数据缓存,下次CacheDispatcher就可以从缓存中获得数据了. 这篇文章,就让			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/v0kynp4.html" rel="bookmark">Flume-ng源码解析之Channel组件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果还没看过Flume-ng源码解析之启动流程,可以点击Flume-ng源码解析之启动流程 查看 1 接口介绍 组件的分析顺序是按照上一篇中启动顺序来分析的,首先是Channel,然后是Sink,最后是Source,在开始看组件源码之前我们先来看一下两个重要的接口,一个是LifecycleAware ,另一个是NamedComponent 1.1 LifecycleAware @[email protected] interface LifecycleAware {  public void s			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MWwJVBM.html" rel="bookmark">给jdk写注释系列之jdk1&period;6容器&lpar;10&rpar;-Stack&amp;amp&semi;Vector源码解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面我们已经接触过几种数据结构了,有数组.链表.Hash表.红黑树(二叉查询树),今天再来看另外一种数据结构:栈. 什么是栈呢,我就不找它具体的定义了,直接举个例子,栈就相当于一个很窄的木桶,我们往木桶里放东西,往外拿东西时会发现,我们最开始放的东西在最底部,最先拿出来的是刚刚放进去的.所以,栈就是这么一种先进后出( First In Last Out,或者叫后进先出) 的容器,它只有一个口,在这个口放入元素,也在这个口取出元素. 栈最主要了两个动作就是入栈和出栈操作,其实还是很容易的明白的对不			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ON61G0.html" rel="bookmark">给jdk写注释系列之jdk1&period;6容器&lpar;12&rpar;-PriorityQueue源码解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PriorityQueue是一种什么样的容器呢?看过前面的几个jdk容器分析的话,看到Queue这个单词你一定会,哦~这是一种队列.是的,PriorityQueue是一种队列,但是它又是一种什么样的队列呢?它具有着什么样的特点呢?它的底层实现方式又是怎么样的呢?我们一起来看一下. PriorityQueue其实是一个优先队列,什么是优先队列呢?这和我们前面讲的先进先出(First In First Out )的队列的区别在于,优先队列每次出队的元素都是优先级最高的元素.那么怎么确定哪一个元素的优			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MGA1qa3.html" rel="bookmark">给jdk写注释系列之jdk1&period;6容器&lpar;6&rpar;-HashSet源码解析&amp;amp&semi;Map迭代器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				今天的主角是HashSet,Set是什么东东,当然也是一种java容器了. 现在再看到Hash心底里有没有会心一笑呢,这里不再赘述hash的概念原理等一大堆东西了(不懂得需要先回去看下HashMap了),需要在啰嗦一句的是hash表是基于快速存取的角度设计的,也是一种典型的空间换时间的做法(这个在分析HashMap中都有讲过).那么今天的HashSet它又是怎么一回事的,他的存在又是为了解决什么问题呢? 先来看下Set的特点:Set元素无顺序,且元素不可以重复. .想到了什么?无顺序,由于散列的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49OVJ10.html" rel="bookmark">Android设计模式源码解析之观察者模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android设计模式源码解析之观察者模式 本文为 Android 设计模式源码解析 中 观察者模式 分析 Android系统版本: 2.3 分析者:Mr.Simple,分析状态:未完成,校对者:Mr.Simple,校对状态:未开始 1. 模式介绍 模式的定义 定义对象间一种一对多的依赖关系,使得每当一个对象改变状态,则所有依赖于它的对象都会得到通知并被自动更新. 模式的使用场景 关联行为场景.需要注意的是,关联行为是可拆分的,而不是&quot;组合&quot;关系: 事件多级触发场景: 跨系统的消息交换			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KbrQOM.html" rel="bookmark">给jdk写注释系列之jdk1&period;6容器&lpar;1&rpar;：ArrayList源码解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文出自吞噬天地,链接整理自ImportNew 给jdk写注释系列之jdk1.6容器(2):LinkedList源码解析 给jdk写注释系列之jdk1.6容器(3):Iterator设计模式 给jdk写注释系列之jdk1.6容器(4)-HashMap源码解析 给jdk写注释系列之jdk1.6容器(5)-LinkedHashMap源码解析 给jdk写注释系列之jdk1.6容器(6)-HashSet源码解析&amp;Map迭代器 给jdk写注释系列之jdk1.6容器(1):ArrayList源码解析 工作中			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r2jYb3.html" rel="bookmark" class="title">使用异步任务加载网络上json数据并加载到ListView中</a>
					<div>
						Android中使用网络访问来加载网上的内容,并将其解析出来加载到控件中,是一种很常见的操作.但是Android的UI线程(也就是主线程)中是不允许进行耗时操作的,因为耗时操作会阻塞主线程,影响用户体 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZAq5q0.html" rel="bookmark" class="title">C&plus;&plus;构造函数语意学&mdash;&mdash;默认构造函数</a>
					<div>
						概述 在 class 中,若程序员没有为该 class object 定义 default constructors,则编译器会根据需要产生一个 implicit default constructo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/418deG3.html" rel="bookmark" class="title">nodejs学习二  深入了解console</a>
					<div>
						上一篇我们用console.log编写了第一个程序,虽然如此简单.那么我就从它来说说Node.js中的对象. 对于学过Java .net 的人来说,对象这个词应该都很亲切,如果不觉得亲切,还是先学习一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38LZER3.html" rel="bookmark" class="title">学习PHP的第五天</a>
					<div>
						列表嵌套					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmOP7Y3.html" rel="bookmark" class="title">转】VB中Set的用法</a>
					<div>
						Set 语句 将对象引用赋给变量或属性. 语法 Set objectvar = {[New] objectexpression | Nothing} Set 语句的语法包含下面部分: 部分 描述 ob ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kGqJl0.html" rel="bookmark" class="title">如何设置NBU的Backup&comma; Archive and Restore</a>
					<div>
						第一行表示Master Server 第二行猜测表示当前主机 第三行不清楚 ? 总结: 1. 这里压根就没有Media Server的事, Media Server对整个备份系统来说是透明的. 2.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02krbA3.html" rel="bookmark" class="title">【转载】Spring中DispatcherServlet与ContextLoaderListener的区别</a>
					<div>
						昨天在写springmvc的时候,在web.xml中配置了DispatcherServlet,如下: &lt;servlet&gt; &lt;servlet-name&gt;DispatcherSer ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWgn14.html" rel="bookmark" class="title">oracle使用LEFT JOIN关联产生的问题在查询结果中使用CASE WHEN 无法判断</a>
					<div>
						oracle使用LEFT JOIN关联产生的问题在查询结果中使用CASE WHEN 无法判断 查询方式一: 1 SELECT 2 CASE WHEN (SELECT CAST(SUM(CASE 3 W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz1KWO4.html" rel="bookmark" class="title">leetcode-【中等题】2&period; Add Two Numbers</a>
					<div>
						题目 You are given two linked lists representing two non-negative numbers. The digits are stored in re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBYYnJ4.html" rel="bookmark" class="title">单链表创建与反转</a>
					<div>
						#include &lt;iostream&gt; #include &lt;fstream&gt; using namespace std; struct LinkNode { int data;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qEPJz3.html" rel="bookmark" class="title">muduo总结</a>
					<div>
						总结说的有的过大,算是对自己学习的一个总结,后续会不断补充. 模型总结 muduo是基于非阻塞的IO和事件驱动的网络库. muduo的整体结构时one loop per thread+threadpo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODOK74.html" rel="bookmark" class="title">06-3&period; 单词长度&lpar;15&rpar;</a>
					<div>
						你的程序要读入一行文本,其中以空格分隔为若干个单词,以‘.’结束.你要输出每个单词的长度.这里的单词与语言无关,可以包括各种符号,比如“it's”算一个单词,长度为4.注意,行中可能出现连续的空格:最 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pPRPx4.html" rel="bookmark" class="title">完整的微信接口类</a>
					<div>
						本类包含了微信官方公布的所有可使用的接口,包括了普通接口及高级接口,具体哪些接口可用还是要看您的账号级别. 具体接口如下: 基础支持 接收消息 发送消息 用户管理 自定义菜单 推广支持 Weixin  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49LxXv3.html" rel="bookmark" class="title">Java public&comma; private&comma; protected and default</a>
					<div>
						Class       Package       Subclass    World public               y             y                 y   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBbxgvM.html" rel="bookmark" class="title">剑指offer&mdash;算法之位运算（二进制中1的个数）</a>
					<div>
						位运算: 左移:m&lt;&lt;n将m左移n位,左移后低位补充0: 右移:m&gt;&gt;n将m右移n位,右移后高位补充的是符号位,负数补充1,整数补充0.(正数的边界值为(1,ox7FFFFFF ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPvBaD3.html" rel="bookmark" class="title">用swift开发计算器</a>
					<div>
						import UIKit class ViewController: UIViewController {     @IBOutlet weak var display: UILabel!       ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPvoW63.html" rel="bookmark" class="title">（六）通过session登录注销</a>
					<div>
						一.index.jsp &lt;form action=&quot;index&quot; method=&quot;get&quot;&gt; 账户:&lt;input type=&quot;tex ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lNgbP4.html" rel="bookmark" class="title">Sqlserver事务发布实现数据同步</a>
					<div>
						事务的功能在sqlserver中由来已久,因为最近在做一个数据同步方案,所以有机会再次研究一下它以及快照等,发现还是有很多不错的功能和改进的.这 里以sqlserver2008的事务发布功能为例,对发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38yw7W4.html" rel="bookmark" class="title">偶遇问题之ORA 600 &lbrack;kkpoxgsoh1</a>
					<div>
						alert.log中报错,查看如下: Fri Jul 18 09:25:50 2014 Errors in file /apps/oracle/diag/rdbms/smsrac/smsrac2/tr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rPbdqM.html" rel="bookmark" class="title">public&comma; protected&comma;  private&comma;internal&comma;protected &NewLine;internal的区别</a>
					<div>
						虽然这个知识比较简单, 但是老是会忘, 写上来, 增强记忆. 在C#语言中,共有五种访问修饰符:public.private.protected.internal.protected internal ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.024 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
